2010-02-26  Mario Carrion  <mcarrion@novell.com>

	* MediaElement.cs: Overriding OnCreateAutomationPeer.

	r: toshok

2010-01-19  Alan McGovern  <amcgovern@novell.com>

	* Control.cs: Add the required handlers for the
	  LostMouseCapture event. Fixes the issue where mouse capture
	  would not be lost correctly on scrollbars.

2009-11-23  Alan McGovern  <amcgovern@novell.com>

	* ItemsPresenter.cs: Change ItemsPresenter to use the
	  TemplateOwner property to find its owning control rather
	  than walking the visual tree, which can break if the
	  template it expanded from contains another ItemsControl.

	* ItemsControl.cs: DOs which are expanded from a
	  ControlTemplate need to keep track of the
	  'templateBindingSource' so that we can attach new
	  TemplateBindings later. This value is stored in addition to
	  'IsTemplateItem' as DOs can be expanded from templates which
	  are not ControlTemplates and only ControlTemplate passes in
	  a non-NULL value for templateBindingSource.

	* ContentPresenter.cs: When creating the default template,
	  ContentPresenter needs to hook up the TemplateBindings to
	  its owning control.

	* ContentControl.cs: ContentControl should not search for its
	  ContentPresenters, it's up to the CP to connect itself.

2009-12-09  Alan McGovern  <amcgovern@novell.com>

	* ItemsControl.cs:
	* ItemContainerGenerator.cs: Give a basic implementation of
	  ItemsContainerGenerator to support the NFL site.

2009-12-08  Rolf Bjarne Kvinge  <RKvinge@novell.com>

	* MediaElement.cs: Stub out LicenseAcquirer.

2009-12-07  Jeffrey Stedfast  <fejj@novell.com>

	* VirtualizingStackPanel.cs (MakeVisible): Made virtual.

	* Control.cs (OnLostMouseCapture): Added.
	(OnMouseWheel): Removed from the #if NET_3_0 block. This is now
	always built since Silverlight 3.0 has this.

2009-12-03  Jeffrey Stedfast  <fejj@novell.com>

	* SelectionMode.cs: Added to the build.

2009-11-25  Alan McGovern  <amcgovern@novell.com>

	* TextBox.cs:
	* Control.cs:
	* PasswordBox.cs: Keep the usage of the Initialize method
	  consistent - add @CallInitialise to the native type if
	  Initialize is required instead of making it virtual and
	  overriding it.

2009-11-20  Larry Ewing  <lewing@novell.com>

	* StackPanel.cs: add a change handler for orientation so that we
	actually update our layout.

2009-11-19  Mario Carrion  <mcarrion@novell.com>

	* Control.cs: New internal event: UIAIsTabStopChanged, raised when
	IsTabStopProperty changes.

	r: toshok

2009-11-18  Alan McGovern  <amcgovern@novell.com>

	* Control.cs: Move the invoking of OnApplyTemplate from
	  Control to FrameworkElement as ContentPresenter (a
	  FrameworkElement) needs to have its OnApplyTemplate method
	  invoked.

2009-11-11  Larry Ewing  <lewing@novell.com>

	* StackPanel.cs: remove the manual visibility checks, they are not
	needed.

2009-11-10  Larry Ewing  <lewing@novell.com>

	* StackPanel.cs: Rework for the new layout rules.

	r: jackson

2009-11-09  Rolf Bjarne Kvinge  <RKvinge@novell.com>

	* MediaElement.cs: Added LogReadyEvent and RequestLog method
	(3.0 API).

	r: toshok

2009-11-09  Sebastien Pouliot  <sebastien@ximian.com> 

	* Control.cs: Extract calls to event_object_do_emit_current_context
	into a new EmitCurrentContext method to reduce the [SSC] required

	r: andreia

2009-11-09  Sebastien Pouliot  <sebastien@ximian.com>

	* MediaElement.cs: Add null-check in both SetSource methods
	and nullify Source on success.

	r: rolf

2009-11-06  Chris Toshok  <toshok@ximian.com>

	* ContentPresenter.cs: InvokeLoaded no longer takes event args
	since it doesn't emit the event.

2009-11-05  Alan McGovern  <amcgovern@novell.com>

	* Control.cs:
	* ItemsControl.cs:
	* ItemsPresenter.cs:
	* ContentControl.cs:
	* ContentPresenter.cs: Templates must be expanded as part of
	  the first step of Measure. To support this, remove the old
	  ApplyTemplateHook managed path and refactor the
	  GetTemplateRoot managed path into a more generic
	  GetDefaultTemplate method. Whenever native code needs to get
	  a default template from managed, this is invoked to retrieve
	  it. ApplyTemplate and OnApplyTemplate have been moved to
	  FrameworkElement itself to simplify the code required to
	  support templateable framework elements (ItemsPresenter for
	  example). r: toshok

2009-11-04  Alan McGovern  <amcgovern@novell.com>

	* ComboBox.cs: 1) Disabling the ComboBox should set
	  IsDropDownOpen to false
	2) If the dropdown is opened while the ComboBox is disabled,
	  the children of the popup are disabled.
	3) If the dropdown is open, re-enabling the ComboBox doesn't
	  close the dropdown and also doesn't update the IsEnabled
	  state on the children.
	r: shana

2009-11-02  Alan McGovern  <amcgovern@novell.com>

	* ContentPresenter.cs: Certain UIElements (Controls and
	  ContentPresenters) need to apply a template before
	  MeasureOverride is invoked. Add a callback
	  (ApplyTemplateHook) to FrameworkElement which is non-null
	  for Controls and ContentPresenters to that these templates
	  can be expanded properly.

2009-10-28  Mario Carrion  <mcarrion@novell.com>

	* ComboBox.cs: Raising UIA event.

	r: alan

2009-10-23  Chris Toshok  <toshok@ximian.com>

	* ComboBox.cs (IsDropDownOpenChanged): only attach to
	LayoutUpdated when the dropdown is open.
	(UpdatePopupSizeAndPosition): if there was an exception in the
	TransformToVisual call, it means it was invoked while not attached
	to a surface, so return early.

	r: shana

2009-10-22  Mario Carrion  <mcarrion@novell.com>

	* TextBox.cs: New internal event: UIATextChanged.
	* TextBlock.cs: New internal event: UIATextChanged.
	* ContentControl.cs: New internal event: UIAContentChanged.

	r: toshok

2009-10-22  Mario Carrion  <mcarrion@novell.com>

	* Control.cs: Raising UIA events:
	AutomationElementIdentifiers.HasKeyboardFocusProperty using
	PostOnGotFocus and PostOnLostFocus.
	* TextBox.cs: New static method TextPropertyChanged used to
	raise UIA event: ValuePatternIdentifiers.ValueProperty. Removed
	internal UIAIsReadOnlyChanged and RaiseIsReadOnlyChanged.
	IsReadOnlyChanged also raises UIA event:
	ValuePatternIdentifiers.IsReadOnlyProperty

	r: toshok

2009-10-09  Mario Carrion  <mcarrion@novell.com>

	* MultiScaleImage.cs: Method overridden OnCreateAutomationPeer.

	r: toshok

2009-10-05  Alan McGovern  <amcgovern@novell.com>

	* Control.cs: Store the starting_generation and only_unemitted
	  flags on the EmitContext so that the values are used when we
	  call DoEmitCurrentContext from managed code. r: toshok

2009-09-29  Chris Toshok  <toshok@ximian.com>

	* Control.cs: split all the OnEventHandlers into PreOnEvent,
	OnEvent, and PostOnEvent method.  the event is emitted in the
	PostOnEvent method.

	* TextBox.cs, PasswordBox.cs: override PostOnKeyDown to handle
	special key events *after* the event has been emitted.

	r: jeff

2009-09-29  Mario Carrion  <mcarrion@novell.com>

	* TextBox.cs: Added: internal method RaiseIsReadOnlyChanged and
	UIAIsReadOnlyChanged.

	r: jeff

2009-09-29  Mario Carrion  <mcarrion@novell.com>

	* PasswordBox.cs: Method overridden OnCreateAutomationPeer.

	r: spouliot

2009-09-28  Chris Toshok  <toshok@ximian.com>

	* Control.cs: add a handler for IsEnabledChangedEvent, and add a
	FIXME for both it and TemplateAppliedEvent, given that they need
	to be handled in a way that insulates them from malicious plugin
	code.

	* TextBox.cs: add a property change handler for IsReadOnlyProperty
	and call ChangeVisualState.  Remove the adding of the
	IsEnabledChanged delegate from the InitializeMethod here, and
	override the control virtual method for handling that.  Also, add
	an InvokeOnApplyTemplate override so we can set the visualstate
	properly after our template has been expanded.

	* PasswordBox.cs: roughly analogous changes as TextBox.cs (except
	the IsReadOnlyProperty stuff).  Also change the ChangeVisualState
	to take the useTransitions parameter.

	* ComboBox.cs: don't UpdateVisualState in Loaded, do it in
	OnApplyTemplate.

	r: jeff

2009-09-28  Alan McGovern  <amcgovern@novell.com>

	* ComboBox.cs: ComboBox.ItemContainerStyle and
	  ListBox.ItemContainerStyle both should update the container
	  item Style value when they change. r: spouliot

2009-09-23  Chris Toshok  <toshok@ximian.com>

	* Control.cs: all the on_method dispatchers need to use the same
	sort of logic as Events.cs, where we look up the native pointer
	before creating a new managed object for it.

	r: lewing
	
2009-09-23  Chris Toshok  <toshok@ximian.com>

	* CursorPositionChangedEventArgs.cs: there's no reason to maintain
	a reference to the native peer in this class.  The fields are all
	read-only and can be initialized in the ctor.

	* PasswordBox.cs: remove all the now-autogenerated events, and use
	event ids instead of names.

	* TextBox.cs: remove all the now-autogenerated events, and use
	event ids instead of names.

	* MultiScaleImage.cs: remove all the now-autogenerated events.

	* MediaElement.cs: remove all the now-autogenerated events.

	* Image.cs: remove all the now-autogenerated events.

	* Control.cs: use Events.AddOnEventHandler for all the On*
	methods.  create safe dispatchers for all of them, and from within
	them we need to call
	NativeMethods.event_object_do_emit_current_context so that the
	unmanaged layer actually emits the event.  This pattern replaces
	all the Invoke* methods.  Remove the manual IsEnabledEvent
	processing, since that is autogenerated now.

	* ContentControl.cs: use event id instead of name when registering
	the handler, and Events.CreateSafeHandler =>
	Events.SafeDispatcher.

	* ContentPresenter.cs (InvokeLoaded): takes a RoutedEventArgs
	parameter.

	* ItemsPresenter.cs (InvokeLoaded): same.

	* ItemsControl.cs (InvokeLoaded): same.

	* ComboBoxItem.cs: remove the namespace.

	r: spouliot, andriea

2009-09-18  Jeffrey Stedfast  <fejj@novell.com>

	* ItemsControl.cs: Removed unused loaded variable.

	* ComboBox.cs: Mark IsSelectionActiveProperty as 'new' to silence
	compiler warnings. Removed unused function and member variable.

	r:kangaroo

2009-09-17  Jeffrey Stedfast  <fejj@novell.com>

	* TextBox.cs: Override ArrangeOverride() and simply chain up.

	r:toshok

2009-09-14  Chris Toshok  <toshok@ximian.com>

	* Image.cs (InvokeImageFailed): we need to create the
	exceptionroutedeventargs from the calldata.

2009-09-11  Larry Ewing  <lewing@novell.com>

	* TextChangedEventArgs.cs: 
	* MultiScaleImage.cs: 
	* MultiScaleSubImage.cs: add missing seal to classes.

2009-09-08  Mario Carrion  <mcarrion@novell.com>

	* ComboBox.cs: Method overridden OnCreateAutomationPeer.

	r: toshok

2009-09-03  Jeffrey Stedfast  <fejj@novell.com>

	* PasswordBox.cs: Override Control's Initialize() method.

	* TextBox.cs: Override Control's Initialize() method.

	* Control.cs: Virtualize the Initialize() method.

2009-09-03  Alan McGovern  <amcgovern@novell.com>

	* ComboBox.cs: ItemContainerStyle should only be copied to the
	  container if it is non-null and there is no existing style.

2009-09-03  Alan McGovern  <amcgovern@novell.com>

	* ComboBox.cs: Remove code duplication - DisplayMemberPath
	  handling should only exist in ItemsControl. This fixes
	  DisplayMemberPath handling for ListBox too. r: sde

2009-09-02  Alan McGovern  <amcgovern@novell.com>

	* ItemsControl.cs: Support for DisplayMemberPath should be
	  implemented by creating a DataTemplate which instantiates a
	  TextBlock with a {Binding} on it. This requires us to clear
	  the container *before* removing it from the panel. r: toshok

	* ComboBox.cs: Add support for DisplayMemberPath r: toshok

2009-09-02  Alan McGovern  <amcgovern@novell.com>

	* ContentPresenter.cs: If ContentPresenter.Content is a
	  UIElement, we clear the value of the DataContext, otherwise
	  we copy the Content to it. r: jeff

2009-08-27  Jeffrey Stedfast  <fejj@novell.com>

	* TextBox.cs: Implement OnMouseLeftButtonDown/Up(), OnMouseMove()
	and update OnGot/LostFocus() to call native methods.

	* PasswordBox.cs: Same.

	r:alan

2009-08-27  Alan McGovern  <amcgovern@novell.com>

	* ComboBox.cs: Limit the dropdown height based on the
	  available height and update the MaxHeight of the ComboBox
	  dropdown when the available height changes. r: spouliot.

2009-08-27  Alan McGovern  <amcgovern@novell.com>

	* ComboBox.cs: 1) Only update the displayed item when the
	  dropdown is closed.
	2) Clicking on the ComboBox itself should toggle the dropdown
	3) If nothing is selected we need to display the fallback item
	  in the content presenter (default specified in
	  generic.xaml). r: jackson

2009-08-27  Alan McGovern  <amcgovern@novell.com>

	* ChangeLog:
	* ComboBox.cs: revert my last commit, it was the wrong patch.

2009-08-26  Alan McGovern  <amcgovern@novell.com>

	* ItemsControl.cs:
	* ItemsPresenter.cs: Allow FrameworkTemplates to be expanded
	  in managed code. Using that, expand the ItemsPanelTemplate
	  in ItemsControl when it is available. r: toshok

2009-08-26  Alan McGovern  <amcgovern@novell.com>

	* ComboBox.cs: ComboBox and ListBox should behave the exact
	  same way when a ListBoxItem is clicked, so share the
	  implementation. r: jackson

2009-08-26  Alan McGovern  <amcgovern@novell.com>

	* ComboBox.cs: ComboBox.IsSelectionActiveProperty and
	  ListBox.IsSelectionActiveProperty are the same DP reference,
	  so declare it on Selector and expose it in the subclasses.
	  Cleanup usage of this property aswell. r: spouliot

2009-08-25  Alan McGovern  <amcgovern@novell.com>

	* ComboBox.cs: When an item is selected before the container
	  item has been created, we need to set the 'IsSelected' flag
	  on the container when it loads. Fixes the initial selection
	  for both ComboBox and ListBox. r: jackson

2009-08-25  Alan McGovern  <amcgovern@novell.com>

	* ComboBox.cs: Rewrite the UpdateDisplayedItem method to fix
	  rendering issues when an item is selected before the drop
	  down list has been opened. Previously the selected item
	  would not appear in the ComboBox as the currently displayed
	  item. r: spouliot

2009-08-24  Alan McGovern  <amcgovern@novell.com>

	* ComboBox.cs: 1) Update the DisplayedItem when the ComboBox
	  template has been applied.
	2) Correctly update the SelectionBoxItem and
	  SelectionBoxItemTemplate variables aswell.
	3) Ensure that the ItemTemplate applied to the selected
	  ComboBoxItem is propagated to
	  ContentPresenter.ContentTemplate
	r: sde

2009-08-15  Larry Ewing  <lewing@novell.com>

	* StackPanel.cs: pass availableSize to the limited
	dimension. 

	Fixes the text layout in Memoriabilia.

	r: jeff

2009-08-15  Rolf Bjarne Kvinge  <RKvinge@novell.com>

	* TextChangedEventArgs.cs:
	* TextBox.cs:
	* PasswordBox.cs: Updated according to API changes in RoutedEventArgs.

	r: andreia

2009-08-14  Alan McGovern  <amcgovern@novell.com>

	* ContentPresenter.cs: Go back to the old method of populating
	  TextBlock.Text in the fallback display element in
	  ContentPresenter. We can't safely use the correct method (a
	  oneway binding) yet. r: lewing

2009-08-13  Larry Ewing  <lewing@novell.com>

	* StackPanel.cs: rework the framework constraints based on drt
	#417.

2009-08-12  Alan McGovern  <amcgovern@novell.com>

	* ContentControl.cs:
	* ContentPresenter.cs: A ContentControl which has no Template
	  needs to call into managed land to create a 'default
	  template'. When the Content is a UIElement, the UIElement is
	  used as the template root, otherwise a Grid + TextBlock
	  (with Binding) is used. This is the same as what
	  ContentPresenter does to its Content property. r: toshok

2009-08-06  Jeffrey Stedfast  <fejj@novell.com>

	* PasswordBox.cs: Sync'd with TextBox.cs for OnKeyUp/Down and
	auto-scrolling.

2009-08-04  Alan McGovern  <amcgovern@novell.com>

	* ContentPresenter.cs: ContentPresenter.Content is copied to
	  the datacontext when it is Loaded.

2009-08-04  Alan McGovern  <amcgovern@novell.com>

	* ContentPresenter.cs: If ContentPresenter.Content was changed
	  from one primitive value to another primitive value (i.e.
	  non-UIElement) then the DataContext was not updated
	  correctly. The DataContext is now kept in sync with the
	  ContentProperty.

2009-07-29  Alan McGovern  <amcgovern@novell.com>

	* TextBox.cs:
	* Control.cs: An extra RaiseKeyDown method is unnecessary -
	  remove it and use InvokeKeyDown properly.

2009-07-29  Alan McGovern  <amcgovern@novell.com>

	* TextBox.cs:
	* Control.cs: 1) TextBox cannot hook into Key press events in
	  unmanaged code otherwise they never propagate to managed and
	  the user cannot intercept them. Instead of hooking to the
	  event in native code, just call native TextBox::OnKeyDown in
	  the managed override.
	2) Key press events are actually handled in two different
	  places. 'Navigation' keypresses like Left/Right/PgUp are
	  handled when the textbox OnKeyDown virtual method is
	  invoked. 'Character' keypresses like 'a', 'b', 'c' are
	  handled after the KeyDown event is emitted
	3) If a key press does not affect the textbox state (i.e.
	  pressing 'left' when the caret is already at the very left),
	  then the keypress is not handled.
	4) The KeyDown event is emitted even if OnKeyDown is overriden
	  and the base method is not invoked.
	5) The tab key should be interpreted as 'Focus next control'
	  only after the KeyDown event handlers have run and the key
	  press is not handled.

2009-07-28  Larry Ewing  <lewing@novell.com>

	* StackPanel.cs: remove uneeded alignment logic.

2009-07-26  Larry Ewing  <lewing@novell.com>

	* ComboBox.cs: set MaxHeight on the real child (hate this hack).
	
2009-07-26  Larry Ewing  <lewing@novell.com>

	* ComboBox.cs: use the new popup hack to handle the popup
	positioning.  Fixes DRT #556.

2009-07-23  Jeffrey Stedfast  <fejj@novell.com>

	* TextBox.cs (OnCursorPositionChanged): Added some special logic
	for the case where the CursorHeight is greater than the
	ViewportHeight. Fixes drt #317.

2009-07-23  Rolf Bjarne Kvinge  <RKvinge@novell.com>

	* MediaElement.cs: Don't treat a native ErrorEventArgs as an
	ExceptionRoutedEventArgs.

2009-07-23  Rolf Bjarne Kvinge  <RKvinge@novell.com>

	* MediaElement.cs: Always provide a *RoutedEventArgs for events.
	Fixes bug #513187.

2009-07-23  Rolf Bjarne Kvinge  <RKvinge@novell.com>

	* MediaElement.cs: InvokeMarkerReached: the calldata we
	get is a pointer to a MarkerReachedEventArgs, not a TimelineMarker.
	
	Fixes bug #523513 and MS DRT #540.

2009-07-21  Larry Ewing  <lewing@novell.com>

	* ComboBox.cs: start dealing with the popup placement.

2009-07-21  Alan McGovern  <amcgovern@novell.com>

	* ItemCollection.cs: In order to make ItemsControl function
	  correctly, it has to box all value types. This appears to
	  break nothing but feels like a bit of a hack. Without this,
	  selection is broken in itemscontrol for value types. 

2009-07-16  Sebastien Pouliot  <sebastien@ximian.com>

	* SaveFileDialog.cs: Update for SL3 final API.

2009-07-13  Alan McGovern  <amcgovern@novell.com>

	* Control.cs: TabNavigation should activate if the control
	  does not handle the Tab key

2009-07-06  Alan McGovern  <amcgovern@novell.com>

	* ItemsControl.cs: ItemsControl should be setting both the
	  Parent and LogicalParent, otherwise DO names aren't
	  registered. Fixes drt 547. 

2009-07-03  Stephane Delcroix  <sdelcroix@novell.com>

	* MultiScaleImage.cs: the generator can do this

2009-07-02  Stephane Delcroix  <sdelcroix@novell.com>

	* MultiScaleImage.cs: use SetValue instead of p/invoking native
	setters.

2009-06-26  Chris Toshok  <toshok@ximian.com>

	* ColumnDefinition.cs: remove explicit property getter.

	* RowDefinition.cs: remove explicit property getter.

2009-06-26  Alan McGovern  <amcgovern@novell.com>

	* ComboBox.cs: Switch ComboBox to use the DropDownToggle
	  template item as the trigger to open/close the popup.

2009-06-26  Alan McGovern  <amcgovern@novell.com>

	* ComboBox.cs: Fix some ListBox focus/selection related bugs.
	  Move ComboBox.OnSelectedItemChanged and
	  ListBox.OnSelectedItemChanged to Selector as they have
	  indentical codepaths after the last refactorings.

2009-06-26  Alan McGovern  <amcgovern@novell.com>

	* ItemsControl.cs: The items added to the contentpresenter are
	  constrained to be UIElements (FrameworkElements?), not
	  ListBoxItems. Therefore keep a dictionary in ItemsControl to
	  map containers to items so we can correctly call
	  ClearContainerForItemOverride when the item is removed. 

2009-06-25  Alan McGovern  <amcgovern@novell.com>

	* ItemsControl.cs: Correctly handle the Reset and Replace
	  events by using AddItemsToPresenter and
	  RemoveItemsFromPresenter.

2009-06-25  Alan McGovern  <amcgovern@novell.com>

	* ComboBox.cs: Propagate MaxDropDownHeight to the popup child.

2009-06-25  Alan McGovern  <amcgovern@novell.com>

	* ComboBox.cs: Move the handling of the ScrollViewer template
	  element and default values of ScrollbarVisibility to the
	  Selector class so it can be shared between ComboBox and
	  ListBox. Fix some default value issues too.

2009-06-25  Alan McGovern  <amcgovern@novell.com>

	* ComboBox.cs: Handle IsDropDownOpenChanged in a non-virtual
	  method.

2009-06-24  Alan McGovern  <amcgovern@novell.com>

	* ComboBox.cs: Add another method to selector to allow
	  subclasses to easily set the IsSelected property when the
	  SelectedItem changes.

2009-06-24  Alan McGovern  <amcgovern@novell.com>

	* ComboBox.cs: The only way to get the initial focus correct
	  for the drop down list in ComboBox is if it receives
	  notification of when its ComboBoxItems are loaded.

2009-06-24  Alan McGovern  <amcgovern@novell.com>

	* ComboBox.cs: Start implementing the required behaviour to
	  handle key presses.

2009-06-19  Rolf Bjarne Kvinge  <RKvinge@novell.com>

	* MultiScaleImage.cs: Use correct event handler type to prevent
	casting exceptions.

2009-06-10  Alan McGovern  <amcgovern@novell.com>

	* ItemsControl.cs: If the ItemsControl is populating from its
	  ItemsSource, we don't set the logical parent. Fixes drt 880.

2009-06-09  Alan McGovern  <amcgovern@novell.com>

	* ComboBox.cs: Implement IsSelectionBoxHighlighted and prevent
	  drt 555 from timing out.

2009-06-04  Alan McGovern  <amcgovern@novell.com>

	* Control.cs: Calling Focus () should result in a recursive Focus.

2009-06-03  Andreia Gaita  <avidigal@novell.com>

	* StackPanel.cs: (MeasureOverride) Children Measure should be called
	with Infinity on width or height depending on the orientation

2009-05-27  Rolf Bjarne Kvinge  <RKvinge@novell.com>

	* MediaElement.cs:
	* Image.cs: Create a ExceptionRoutedEventArgs with default/TODO
	  values, prevents a lot of the MS tests from throwing NRE and
	  timing out.

2009-05-27  Alan McGovern  <amcgovern@novell.com>

	* Control.cs: Control.Enabled needs to be created in native
	  code as it's required for hittesting. A disabled control and
	  its visual children do not receive mouse events and are not
	  visible to VisualTreeHelper.FindElementInHostCoordinates.

2009-05-26  Alan McGovern  <amcgovern@novell.com>

	* TextBox.cs: Add missing VisualState transitions to TextBox.

2009-05-22  Alan McGovern  <amcgovern@novell.com>

	* ComboBox.cs
	* ContentPresenter.cs
	* Control.cs
	* ItemsControl.cs
	* StackPanel.cs:
	Use DependencyProperty.RegisterCore for these DPs.

2009-05-21  Jackson Harper  <jackson@ximian.com>

	* ComboBox.cs: Cleanup debug spew so it doesn't cause a crash when
	non FrameworkElement objects are added to the combo box.

2009-05-21  Alan McGovern  <amcgovern@novell.com>

	* ItemsControl.cs: Add the required VisualState changes to
	PasswordBox.
	
2009-05-21  Alan McGovern  <amcgovern@novell.com>

	* ItemsControl.cs: InvokeItemsChanged shouldn't be virtual.
	
2009-05-18  Larry Ewing  <lewing@novell.com>

	* StackPanel.cs: take max/min into account in layout.

2009-05-18  Alan McGovern  <amcgovern@novell.com>

	* ContentPresenter.cs: For contentcontrols, the applied
	  template is only cleared if the old or new content is a
	  UIElement (frameworkelement?). The fallback 'template' of a
	  Grid + TextBlock is also reused every time.

2009-05-18  Alan McGovern  <amcgovern@novell.com>

	* ItemsControl.cs: Cosmetic - Remove some C.W.Ls

2009-05-15  Alan McGovern  <amcgovern@novell.com>

	* RowDefinition.cs:
	* ColumnDefinition.cs: These should both be sealed.

2009-05-13  Alan McGovern  <amcgovern@novell.com>

	* ItemsControl.cs: When the items collection is databound, we
	  need to copy all the items from the ItemsSource into the
	  Items collection before firing the Reset event.

2009-05-13  Larry Ewing  <lewing@novell.com>

	* ItemsControl.cs: access the Property not the member to avoid a
	crash.

2009-05-13  Alan McGovern  <amcgovern@novell.com>

	* ContentPresenter.cs: Measure needs to be invalidated every
	  time the Content or ContentTemplate changes, not just when
	  we alter the root visual.

2009-05-12  Alan McGovern  <amcgovern@novell.com>

	* ItemsControl.cs: ItemsControl has the same behaviour as
	  ContentPresenter - the DataContext property is only set if
	  the item is *not* a framework element.

2009-05-12  Alan McGovern  <amcgovern@novell.com>

	* ContentPresenter.cs: ContentPresenter copies Content to
	  DataContext iff the Content is not a FrameworkElement.

2009-05-12  Jeffrey Stedfast  <fejj@novell.com>

	* TextBox.cs (OnCursorPositionChanged): Fixed scrolling to behave
	more normally. Might still need some work, but at least it's no
	longer painful. I'm sure toshok will be appreciative ;-)

2009-05-12  Alan McGovern  <amcgovern@novell.com>

	* ItemsControl.cs:
	* ItemCollection.cs: The ItemsCollection should be
	  instantiated once and reused even when the ItemsSource
	  changes. When ItemsSource is non-null, we don't propagate
	  collection changed events.

2009-05-11  Alan McGovern  <amcgovern@novell.com>

	* ContentPresenter.cs: Whenever the content root is changed,
	  we need to invalidate the measure so that the presenter
	  refreshes properly.

2009-05-11  Alan McGovern  <amcgovern@novell.com>

	* ContentPresenter.cs: Recommit r133738 as it's not causing
	  the timeouts.

2009-05-11  Alan McGovern  <amcgovern@novell.com>

	* ContentPresenter.cs: Recommit r133724/5 as it isn't causing
	  the timeouts.

2009-05-11  Alan McGovern  <amcgovern@novell.com>

	* ItemsControl.cs:
	* ContentPresenter.cs: When a container is autogenerated, we
	  copy the Content to the DataContext.

2009-05-11  Alan McGovern  <amcgovern@novell.com>

	* ContentPresenter.cs: Back out r133724/5 in case it's what
	  has caused the random failures in the extended controls
	  tests.

2009-05-08  Alan McGovern  <amcgovern@novell.com>

	* ContentPresenter.cs: Revert the changes in r133738 until I
	  can figure out why the x86 bot doesn't like them. It's
	  causing the extended controls tests to time out.

2009-05-08  Alan McGovern  <amcgovern@novell.com>

	* ContentPresenter.cs: That debug spew wasn't supposed to hit
	  SVN

2009-05-07  Alan McGovern  <amcgovern@novell.com>

	* ContentPresenter.cs: If the content property changes, the
	  Template is cleared if it has already been applied.

2009-05-07  Alan McGovern  <amcgovern@novell.com>

	* ItemsPresenter.cs: ItemsPresenter should be hooking itself
	  in during the first MeasureOverride as opposed to when it's
	  loaded. This matches the MS behaviour.

2009-05-07  Alan McGovern  <amcgovern@novell.com>

	* ContentPresenter.cs: I seem to have mangled that last patch
	  before committing - fix the build.

2009-05-07  Alan McGovern  <amcgovern@novell.com>

	* ContentPresenter.cs: 1) The 'Content' property of the
	  ContentPresenter is not copied to DataContext.
	2) If the expanded DataTemplate is null, fall back to
	  displaying the Content.

2009-05-03  Chris Toshok  <toshok@ximian.com>

	* ContentControl.cs (WalkTreeForContentPresenters): not sure why
	we passed "this" to this method.  Just use this instead of
	templateRoot.  Also, use a more verbose TemplateBindingExpression
	initialization.

2009-05-01  Alan McGovern  <amcgovern@novell.com>

	* ContentControl.cs: If the default ContentPresenter is
	  replaced in a ContentControl, we need to TemplateBind both
	  the Content and ContentTemplate.

2009-04-28  Alan McGovern  <amcgovern@novell.com>

	* ItemsControl.cs: Ensure that PrepareContainerForItemOverride
	  is handling both ContentControls and ContentPresenters
	  correctly.

2009-04-28  Alan McGovern  <amcgovern@novell.com>

	* ComboBox.cs: Copy over the styles/templates to the items
	  from the ComboBox.
	Clicking the ToggleButton should open the dropdown.
	When a ComboBoxItem is autogenerated, we need to store the
	  autogenerated box in DisplayedItem so that we can put its
	  content back later on.

	* ItemsControl.cs: Generate the container only when it's
	  required. When the container is a ContentControl, ensure
	  that the container doesn't try to set the items logical
	  parent.

2009-04-28  Alan McGovern  <amcgovern@novell.com>

	* ComboBoxItem.cs: MouseUp should result in the popup being
	  closed but the selection is not changed.

2009-04-28  Alan McGovern  <amcgovern@novell.com>

	* ContentControl.cs: Add the ability to stop ContentControl
	  from automatically setting the LogicalParent when a
	  FrameworkElement is added as the Content.

2009-04-24  Alan McGovern  <amcgovern@novell.com>

	* ComboBox.cs: Ensure that the currently selected item is
	  displayed correctly when the popup is not open.

2009-04-23  Alan McGovern  <amcgovern@novell.com>

	* ComboBox.cs: Clicking on ListItems in the combobox popup
	  should close the popup.

2009-04-23  Alan McGovern  <amcgovern@novell.com>

	* ComboBox.cs: Allow popups to use a transparent canvas to
	  catch clicks outside of the popup area. ComboBox uses this
	  to close its popup.

2009-04-23  Alan McGovern  <amcgovern@novell.com>

	* ComboBoxItem.cs: Removing unnecessary override

2009-04-23  Alan McGovern  <amcgovern@novell.com>

	* ComboBox.cs: Move the Notify* methods into Selector as both
	  Listbox and ComboBox require the same API.

2009-04-23  Alan McGovern  <amcgovern@novell.com>

	* ItemsControl.cs: FrameworkElements added to an
	  ItemsCollection need to have their logical parent set to the
	  ItemsControl.

2009-04-22  Alan McGovern  <amcgovern@novell.com>

	* ComboBox.cs: Add missing nullcheck around access to a
	  templated part.

2009-04-22  Alan McGovern  <amcgovern@novell.com>

	* ComboBox.cs: ComboBox should return a new ComboBoxItem
	  without applying the container style.

2009-04-22  Alan McGovern  <amcgovern@novell.com>

	* ItemsPresenter.cs: After some extensive testing in
	  silverlight, I think this change is correct. When templating
	  ComboBox, the Popup used to display the items has no visual
	  parent but does have a logical parent. Therefore the only
	  way to connect the ItemsPresenter to the ItemsControl is to
	  fall back to the logical parent when the VisualParent is
	  null. I'm not sure if this is popup specific behaviour or if
	  this is true for all controls which have a null visual
	  parent but non-null logical parent.

2009-04-17  Alan McGovern  <amcgovern@novell.com>

	* ComboBox.cs: Make IsSelectionActive work. Also make showing
	  the popup work. Currently no items are being displayed in
	  the popup as the ItemsPresenter is never getting loaded.

2009-04-17  Sebastien Pouliot  <sebastien@ximian.com>

	* SaveFileDialog.cs: Implement DefaultExtbehavior

2009-04-15  Alan McGovern  <amcgovern@novell.com>

	* ItemsControl.cs: When an ItemsControl is templated, don't
	  replace the templated visual tree with the ItemsPresenters
	  visual tree.

	* ItemsPresenter.cs: ItemsPresenter should search the visual
	  tree, not logical tree, when trying to find its ItemsControl

2009-04-14  Rolf Bjarne Kvinge  <RKvinge@novell.com>

	* OpenFileDialog.cs:
	* SaveFileDialog.cs: Generate all P/Invoke methods.

2009-04-13  Rolf Bjarne Kvinge  <RKvinge@novell.com>

	* ClickMode.cs:
	* generic.xaml:
	* Orientation.cs:
	* ProgressBar.cs: Delete files we got from MS' controls drop,
	  and update project file to compile.

2009-04-09  Jeffrey Stedfast  <fejj@novell.com>

	* PasswordBox.cs, TextBlock.cs, TextBox.cs: Removed manual stub
	for FontSource property, these are now autogenerated.

2009-04-09  Sebastien Pouliot  <sebastien@ximian.com>

	* OpenFileDialog.cs: Free the memory we receive from 
	open_file_dialog_show
	* SaveFileDialog.cs: New. Silverlight 3 feature

2009-04-08  Stephane Delcroix  <sdelcroix@novell.com>

	* MultiScaleImage.cs: no longer throws NIE on LogicalToElementPoint

2009-04-07  Chris Toshok  <toshok@ximian.com>

	* ContentPresenter.cs: turns out my layout fears were unfounded.
	Removing the grid will give us the same layout characteristics as
	silverlight.  Alan was right about the different visual tree under
	CP.  Duplicate this tree so that it matches SL in all 3 cases: 1)
	UIElement content (directly a child of contentpresenter), 2)
	string content (grid -> textblock), and 3) no content (no children
	under contentpresenter.)  This simplifies PrepareContentPresenter
	quite a bit.

2009-04-06  Chris Toshok  <toshok@ximian.com>

	* Control.cs (set_DefaultStyleKey): add a few more error
	conditions (surrounding UserControlType) to get 2.0 ms test
	fixture 552 closer to working.

2009-04-06  Stephane Delcroix  <sdelcroix@novell.com>

	* MultiScaleImage.cs: lookup the new DPs and new properties

2009-04-03  Alan McGovern  <amcgovern@novell.com>

	* TextBox.cs: TextBox does validation in both the getter and
	  setter of its TextProperty, so we have to manually implement
	  it.

2009-04-02  Aaron Bockover  <abockover@novell.com>

	* ContentPresenter.cs: Nuke a BOM on which gmcs 2.0.1 explodes

2009-03-30  Chris Toshok  <toshok@ximian.com>

	* Control.cs: track change of MouseButton -> MouseLeftButton, and
	add MouseRightButtonUp/Down and MouseWheel.


2009-03-27  Chris Toshok  <toshok@ximian.com>

	* ItemsControl.cs: only install our default ItemsPresenter if
	there isn't a template that's going to be applied to this element.
	In the case of a template either 1 of 2 things will happen.
	Either there's an ItemsPresenter someplace in the template, and
	ItemsPresenter.InvokeLoaded grovels up the tree until it finds
	this ItemsControl, calling SetItemsPresenter on it, or the control
	deals with all the Items changes manually (as in TabControl) and
	we never have an ItemsPresenter.

2009-03-27  Stephane Delcroix  <sdelcroix@novell.com>

	* MultiScaleImage.cs: MotionFinished is a RoutedEvent

2009-03-26  Jeffrey Stedfast  <fejj@novell.com>

	* PasswordBox.cs: We no longer do the evil gross hackery action.

	* TextBox.cs: Updated NativeMethods use for text_box_base

2009-03-25  Stephane Delcroix  <sdelcroix@novell.com>

	* MultiScaleImage.cs: ViewportChanged is a RoutedEvent

2009-03-23  Jeffrey Stedfast  <fejj@novell.com>

	* TextBox.cs: Connect to our CursorPositionChanged event so we can
	update the scrollviewer offsets.

2009-03-18  Jeffrey Stedfast  <fejj@novell.com>

	* Control.cs: Use NativeMethods.control_focus() instead of
	NativeMethods.surface_focus_element().

2009-03-17  Jb Evain  <jbevain@novell.com>

	* Grid.cs: override and seal ArrangeOverride and MeasureOverride.

2009-03-10  Jeffrey Stedfast  <fejj@novell.com>

	* PasswordBox.cs: Manually bind the PasswordProperty and the
	getter/setter. Don't allow the Password getter to return null.

2009-03-10  Jeffrey Stedfast  <fejj@novell.com>

	* PasswordBox.cs: Connect to TextChanged instead of
	PasswordChanged events on the unmanaged side, since the unmanaged
	code subclasses TextBox we'll just reuse the same event. Also, map
	SelectionBackground and SelectionForeground properties to the
	TextBox properties manually.

2009-03-09  Jeffrey Stedfast  <fejj@novell.com>

	* TextBox.cs: Use ObjectFromIntPtr instead of GCHandle. Doh.

2009-03-06  Andreia Gaita  <avidigal@novell.com>

	* ContentControl.cs, Image.cs, MediaElement.cs,
	  MultiScaleImage.cs, PasswordBox.cs,
	  TextBox.cs: Switch to using ObjectFromIntPtr to lookup objects.

2009-03-04  Stephane Delcroix  <sdelcroix@novell.com>

	* MultiScaleImage.cs: use the native setters instead of the
	SetValue for ViewportOrigin and Width

2009-02-26  Chris Toshok  <toshok@ximian.com>

	* ItemsControl.cs: land some longstanding local changes.

	* ItemsPresenter.cs: same.

2009-02-26  Chris Toshok  <toshok@ximian.com>

	* ContentControl.cs (InvokeOnApplyTemplate): override
	FrameworkElement's implementation so we can walk our visual
	subtree calling OnApplyTemplate and add the default
	TemplateBinding for ContentPresenter.ContentProperty (if there
	isn't one already) on all ContentPresenters that are our
	descendents (without an intervening control.)

2009-02-18  Rolf Bjarne Kvinge  <RKvinge@novell.com>

	* MediaElement.cs: Initial implementation of
	  MediaStreamSource.

2009-02-18  Alan McGovern  <amcgovern@novell.com>

	* TextBox.cs: There are no HitTest methods on TextBox in the
	  SL 2.0 api

2009-02-13  Jeffrey Stedfast  <fejj@novell.com>

	* MultiScaleImage.cs: Manually bind the DependencyProperties and
	the property accessors.

2009-02-12  Alan McGovern  <amcgovern@novell.com>

	* ItemCollection.cs: Managed objects are stored in native as
	  GCHandles. Use the mono api to get the target of that
	  GCHandle so that they can be compared correctly in
	  value.cpp. Remove hack in ItemCollection.cs which worked
	  around this bug.

2009-02-08  Chris Toshok  <toshok@ximian.com>

	* ItemsControl.cs (PrepareContainerForItemOverride): if
	DisplayMemberPath is set, create a binding and hook it up to the
	content presenter's ContentProperty.

2009-02-08  Sebastien Pouliot  <sebastien@ximian.com>

	* TextBlock.cs: Implement OnCreateAutomationPeer

2009-02-06  Larry Ewing  <lewing@novell.com>

	* ContentPresenter.cs: don't compare against _elementText compare
	against null.

2009-02-05  Chris Toshok  <toshok@ximian.com>

	* ItemsControl.cs: implement basic databinding support - no
	templates, no DisplayMemberPath, just a databound ItemsSource with
	INotifyCollectionChanged handling.

	* ItemCollection.cs: add SetReadOnly so ItemsControl can mark the
	collection as readonly (only for the user, the collection remains
	modifiable by the control).

2009-02-05  Larry Ewing  <lewing@novell.com>

	* StackPanel.cs: skip collapsed children.

2009-02-05  Geoff Norton  <gnorton@novell.com>

	* MultiScaleImage.cs: We hide the SubImages in a internal DP for now
	until we can automatically generated a ReadOnlyCollection from 	
	a native counterpart in the generator.

2009-02-05  Geoff Norton  <gnorton@novell.com>

	* MultiScaleSubImageCollection.cs: Managed counterpart to the native
	collection.

2009-02-04  Sebastien Pouliot  <sebastien@ximian.com>

	* TextBlock.cs: Change the NotImplementedException into a MonoTODO
	to get Tetrislite go further

2009-02-04  Chris Toshok  <toshok@ximian.com>

	* ItemsControl.cs: flesh out some of the implementation in the
	non-databound scenario (using the Items collection).

	* ItemsPresenter.cs: create a stackpanel for the time being, since
	that seems to be what the default behavior is.

	* ComboBox.cs: flesh out the implementation and fix up the
	gui-compare.

	* ComboBoxItem.cs: gui-compare stuff.

2009-02-04  Larry Ewing  <lewing@novell.com>

	* StackPanel.cs: remove the restriction on size of the visible
	children it breaks since that uses a rendertransform to make
	things visible again.

2009-02-04  Larry Ewing  <lewing@novell.com>

	* StackPanel.cs: rework the alignment logic to match some of the
	new tests.

2009-02-04  Alan McGovern  <amcgovern@novell.com>

	* HitTestCollection.cs: Hook up the managed hittesting code
	  to the native hit testing code.

2009-02-02  Chris Toshok  <toshok@ximian.com>

	* UserControl.cs: remove the ContentProperty attribute - we
	autogenerate it now

	* Border.cs: same.

2009-02-02  Chris Toshok  <toshok@ximian.com>

	* ComboBox.cs: set DefaultStyleKey in the ctor to pick up the
	right template.

2009-01-30  Chris Toshok  <toshok@ximian.com>

	* Control.cs (Initialize): register empty delegates on all the
	events we expose in the form of On$Event methods, so our methods
	are called.

2009-01-30  Jeffrey Stedfast  <fejj@novell.com>

	* TextBox.cs: Fixed SelectionChanged

2009-01-30  Larry Ewing  <lewing@novell.com>

	* StackPanel.cs: only use the alignment logic if the dimentions
	aren't specified.

2009-01-29  Sebastien Pouliot  <sebastien@ximian.com>

	* ItemCollection.cs: Override IndexOfImpl so we can compare
	objects in the managed side.

2009-01-26  Larry Ewing  <lewing@novell.com>

	* StackPanel.cs: improve the logic and add horizontal support.

2009-01-26  Jeffrey Stedfast  <fejj@novell.com>

	* ContentControl.cs (content_changed_callback): Fixed cast
	exception for the event args.

	* TextBox.cs (text_changed_cb): Fixed some cast exceptions and
	also pass our EventArgs to InvokeTextChanged().

2009-01-26  Geoff Norton  <gnorton@novell.com>

	* Control.cs: Surface lives in Deployment now.

2009-01-26  Chris Toshok  <toshok@ximian.com>

	* ContentPresenter.cs (PrepareContentPresenter): call
	uielement_set_subtree_object here to hook the _elementRoot into
	the visual tree.
	
2009-01-25  Chris Toshok  <toshok@ximian.com>

	* ContentPresenter.cs: move the 90% implementation back here.

	* Control.cs: don't register the DefaultStyleKey property - the
	unmanaged code already does it.  Just look it up here.

2009-01-22  Jeffrey Stedfast  <fejj@novell.com>

	* ContentPresenter.cs: Simplified by ripping out most of the code
	that was moved to c++.

	* ContentControl.cs: Simplified a lot by re-using the Events class
	helper functions.

	* ContentPresenter.cs: New binding to unmanaged ContentPresenter
	class. Replaces the old ContentPresenetr class from the Microsoft
	Silverlight b1 sources.

2009-01-21  Geoff Norton  <gnorton@novell.com>

	* Image.cs: Clean up stuff that should (and now is) have been 
	generated.

2009-01-21  Jeffrey Stedfast  <fejj@novell.com>

	* ContentControl.cs: Connect to the internal ContentChanged event
	so that we can call the virtual OnContentChanged() method.

2009-01-20  Chris Toshok  <toshok@ximian.com>

	* Control.cs: we no longer need to override InvokeLoaded - the
	style process is driven in unmanaged code.  Also clean up the
	handling of DefaultStyleKey - we can't throw an exception in the
	changed handler.  it has to be thrown before the value is changed.
	Get rid of the change handler.

	* TextBox.cs: get rid of the Initialize method.
	
2009-03-15  Alan McGovern  <amcgovern@novell.com>

	* Image.cs:
	* TextBox.cs:
	* Control.cs:
	* PasswordBox.cs:
	* MediaElement.cs:
	* MultiScaleImage.cs: Simplify how native events are connected to in
	managed code. The managed add/remove event methods just call
	RegisterEvent/UnregisterEvent defined in DO.cs instead of each event
	managing the event list itself.

2009-01-19  Alan McGovern  <amcgovern@novell.com>

	* Image.cs:
	* TextBox.cs:
	* PasswordBox.cs:
	* MediaElement.cs:
	* MultiScaleImage.cs: Change all our native callbacks to use a wrapped
	handler which traps managed exceptions.

2009-01-18  Geoff Norton  <gnorton@novell.com>

	* MediaElement.cs: These are RoutedEventHandlers, not EventHandlers.
	Fixes a InvalidCastException with PDC.

2009-01-16  Jeffrey Stedfast  <fejj@novell.com>

	* TextBox.cs (ArrangeOverride): Removed.

2009-01-15  Rolf Bjarne Kvinge  <RKvinge@novell.com>

	* MediaElement.cs: Tiny little beginning of MediaStreamSource and remove
	a few members which can be generated now that the native MediaElement
	doesn't inherit from MediaBase anymore.

2009-01-15  Alan McGovern  <amcgovern@novell.com>

	* ComboBox.cs:
	* ComboBoxItem.cs: Begin implementing ComboBox. First 3 tests now pass.

2009-01-15  Sebastien Pouliot  <sebastien@ximian.com>

	* ItemCollection.cs: Override NullCheck to throw ArgumentExpcetion
	for all null values (instead of the default ArgumentNullException
	on _some_ null values).

2009-01-13  Sebastien Pouliot  <sebastien@ximian.com>

	* StackPanel.cs: Seal overrides to please gui-compare

2009-01-12  Rolf Bjarne Kvinge  <RKvinge@novell.com>

	* TextBlock.cs:
	* MultiScaleImage.cs: Corcompare issues.

2009-01-12  Andreia Gaita  <avidigal@novell.com>

	* StackPanel.cs: New managed implementation (only vertical
 	  orientation)

2009-01-09  Sebastien Pouliot  <sebastien@ximian.com> 

	* ItemsControl.cs: Implemented a bit more

2009-01-08  Sebastien Pouliot  <sebastien@ximian.com> 

	* ItemsControl.cs: Partial implementation (enough to pass some 
	controls unit tests)

2009-01-08  Sebastien Pouliot  <sebastien@ximian.com>

	* ItemCollection.cs: Change to partial class

2009-01-07  Chris Toshok  <toshok@ximian.com>

	* Control.cs (Control.InvokeLoaded): get the default style for the
	control if it has a DefaultStyleKey.  We don't do anything with it
	yet, but this process drives the parsing of generic.xaml.

2009-01-06  Alan McGovern  <amcgovern@novell.com>

	* PasswordBox.cs: Ensure correct exception is thrown when a null string
	is passed to PasswordBox.Password. Use correct range validation for
	MaxLength.

2008-12-19  Rolf Bjarne Kvinge <RKvinge@novell.com> 

	* PasswordBox.cs, ItemsPresenter.cs: More bits.
	* CalendarMode.cs: Deleted, this file goes in
	  System.Windows.Controls.dll.

2008-12-19  Sebastien Pouliot  <sebastien@ximian.com>

	* Control.cs: Remove OnIsEnabled hack for needed by beta1 controls.

2008-12-19  Rolf Bjarne Kvinge <RKvinge@novell.com> 

	* CalendarMode.cs, ComboBox.cs, ComboBoxItem.cs: Stub out and fill in
	  more bits to get even more bits compiling.

2008-12-11  Chris Toshok  <toshok@ximian.com>

	* Control.cs: add Initialize method to add a handler for the
	TemplateApplied unmanaged event.  Call
	FrameworkElement.OnApplyTemplate from there.

2008-12-11  Chris Toshok  <toshok@ximian.com>

	* Control.cs: implement GetTemplateChild.

2008-12-11  Rolf Bjarne Kvinge <RKvinge@novell.com> 

	* PasswordBox.cs: Stub out to fix build.

2008-12-10  Full Name  <Email Address>

	* TextBox.cs: Commit the files from the generator.

2008-12-10  Full Name  <Email Address>

	* TextBox.cs:
	* PasswordBox.cs: Partial implementation of the PasswordBox control

2008-12-09  Sebastien Pouliot  <sebastien@ximian.com> 

	* UserControl.cs: Remove IsTabStop initialization (moved to 
	unmanaged code)

2008-12-08  Sebastien Pouliot  <sebastien@ximian.com> 

	* UserControl.cs: Add Initialize and set IsTabStop to false

2008-12-08  Sebastien Pouliot  <sebastien@ximian.com>

	* Control.cs: Add null check on EventArgs for all On* methods.
	Check Handled (when provided) before making the calls to On*.
	Re-use internal 'events' for IsEnabledChanged

2008-12-05  Sebastien Pouliot  <sebastien@ximian.com> 

	* ProgressBar.cs: Default is 1 (not 100) in SL2 final.

2008-12-05  Sebastien Pouliot  <sebastien@ximian.com>

	* Control.cs: Override Invoke* methods and call our On* methods
	before the base method (that fire the events).

2008-12-05  Stephane Delcroix  <sdelcroix@novell.com>

	* ProgressBar.cs:
	* generic.xaml: managed implementation of the progressbar, and 
	default template.

2008-12-04  Sebastien Pouliot  <sebastien@ximian.com>

	* Control.cs: Change OnIsEnabledChanged to internal so it does not
	show as extra here and on other controls

2008-12-04  Sebastien Pouliot  <sebastien@ximian.com> 

	* Control.cs: Add protected OnIsEnabledChanged since all controls
	depends on it and it's not in ContentControl anymore.

2008-12-04  Sebastien Pouliot  <sebastien@ximian.com>

	* Control.cs: Add back DefaultStyleKey and IsEnabled with managed
	validation and events.

2008-12-02  Sebastien Pouliot  <sebastien@ximian.com>

	* Control.cs: Remove temporary properties (they are now generated)

2008-12-02  Stephane Delcroix  <sdelcroix@novell.com>

	* ProgressBar.cs: stubbed to pass basic unit-tests

2008-12-02  Andreia Gaita  <shana@jitted.com>

	* System.Windows.Controls/StackPanel.cs: Implement ArrangeOverride
	and MeasureOverride

2008-11-28  Sebastien Pouliot  <sebastien@ximian.com> 

	* Control.cs (GetTemplateChild): Throw only if childName is null
	otherwise return null (for the moment) since it's the "default"
	action (see tests).

2008-11-28  Sebastien Pouliot  <sebastien@ximian.com>

	* ItemCollection.cs: Remove public ctor.
	* OpenFileDialog.cs: Fix Filter and FilterIndex properties.
	* TextChangedEventArgs.cs: Internalize default ctor.

2008-11-27  Sebastien Pouliot  <sebastien@ximian.com>

	* OpenFileDialog.cs: Replace "old" FileDialogFileInfo with standard
	FileInfo. Remove title since it's not user settable anymore. Rename
	properties.

2008-11-25  Sebastien Pouliot  <sebastien@ximian.com>

	* ValidationError.cs: New. Needed for FrameworkElement.
	* ValidationErrorEventArgs.cs: New. Needed for FrameworkElement.

2008-11-25  Stephane Delcroix  <sdelcroix@novell.com>

	* MultiScaleImage.cs: ElementToLogicalPoint impl.

2008-11-19  Rolf Bjarne Kvinge <RKvinge@novell.com> 

	* Canvas.cs, Control.cs, MediaElement.cs: Corcompare fixes.

2008-11-18  Rolf Bjarne Kvinge <RKvinge@novell.com> 

	* ColumnDefinitionCollection.cs, MediaElement.cs, ItemCollection.cs,
	  UIElementCollection.cs, RowDefinitionCollection.cs: Corcompare
	  work.

2008-09-02  Stephane Delcroix  <sdelcroix@novell.com>

	* MultiScaleImage.cs: stub

2008-09-01  Stephane Delcroix  <sdelcroix@novell.com>

	* MultiScaleSubImage.cs: stub

2008-08-24  Geoff Norton  <gnorton@novell.com>

	* Image.cs: Support nulling out the ImageSource

2008-08-24  Geoff Norton  <gnorton@novell.com>

	* Image.cs: ImageSource now does the heavy lifting for us.

2008-08-23  Geoff Norton  <gnorton@novell.com>

	* Image.cs: If we dont have a stream of the image available from
	BitmapImage, get it.

2008-08-22  Jeffrey Stedfast  <fejj@novell.com>

	* TextChangedEventArgs.cs: Added.

	* TextChangedEventHandler.cs: Added.

	* TextBox.cs: Implemented events.

2008-08-22  Jeffrey Stedfast  <fejj@novell.com>

	* TextBox.cs: Implemented Select() and stubbed out the other
	methods.

2008-08-21  Chris Toshok  <toshok@ximian.com>

	* Border.cs: added

2008-08-21  Jeffrey Stedfast  <fejj@novell.com>

	* TextBox.cs: Added to the build.

2008-08-19  Jeffrey Stedfast  <fejj@novell.com>

	* MediaElement.cs (SetSource): Handle null inputs, it is not an
	exception case.

2008-08-18  Chris Toshok  <toshok@ximian.com>

	* Control.cs: implement Focus.

2008-08-18  Geoff Norton  <gnorton@novell.com>

	* Control.cs: Add DefaultStyleKey

2008-08-18  Geoff Norton  <gnorton@novell.com>

	* Image.cs: Implement Image.Source = BitmapImage(Stream)

2008-08-15  Rolf Bjarne Kvinge <RKvinge@novell.com> 

	* MediaElement.cs: Implement MediaElement.SetSource (stream)

2008-08-14  Geoff Norton  <gnorton@novell.com>

	* MediaElement.cs: Turn the Stream SetSource calls into warnings
	to prevent us crashing until we've implemented those bits.

2008-08-14  Rolf Bjarne Kvinge <RKvinge@novell.com> 

	* MediaElement.cs: Removed classes and members which are no longer in
	  SL2B2.

2008-08-13  Larry Ewing  <lewing@novell.com>

	* MediaElement.cs: fix the type of MediaEnded to
	RoutedEventHandler.

2008-08-13  Rolf Bjarne Kvinge <RKvinge@novell.com> 

	* Canvas.cs: Changed some parameter names, base types, method
	  signatures, etc to match SL.

2008-08-13  Rolf Bjarne Kvinge <RKvinge@novell.com> 

	* StackPanel.cs: Added a native StackPanel class and generate the
	  managed StackPanel.

2008-08-13  Rolf Bjarne Kvinge <RKvinge@novell.com> 

	* ContentControl.cs: Deleted, we're using MS' source for this class.

2008-08-12  Chris Toshok  <toshok@ximian.com>

	* ControlTemplate.cs: remove the TargetType CLR wrapper, it's
	autogenerated now.

2008-08-12  Rolf Bjarne Kvinge <RKvinge@novell.com> 

	* ControlTemplate.cs, Image.cs, UIElementCollection.cs: Remove more
	  code, add more partial modifiers and fix DependencyObject.g.cs
	  whitespace problem.

2008-08-12  Rolf Bjarne Kvinge <RKvinge@novell.com> 

	* Canvas.cs, ColumnDefinition.cs, ColumnDefinitionCollection.cs,
	  Control.cs, Grid.cs, InkPresenter.cs, MediaElement.cs, Panel.cs,
	  RowDefinition.cs, RowDefinitionCollection.cs, TextBlock.cs,
	  UserControl.cs: Generate public ctor, internal ctor and GetKind for
	  classes inheriting from DependencyObject.

2008-08-12  Rolf Bjarne Kvinge <RKvinge@novell.com> 

	* Canvas.cs: Spaces->Tabs.

2008-08-12  Rolf Bjarne Kvinge <RKvinge@novell.com> 

	* ColumnDefinitionCollection.cs, RowDefinitionCollection.cs: Make
	  classes partial.

2008-08-12  Rolf Bjarne Kvinge <RKvinge@novell.com> 

	* Canvas.cs, UserControl.cs, Control.cs, RowDefinition.cs, Grid.cs,
	  MediaElement.cs, TextBlock.cs, Panel.cs, ColumnDefinition.cs,
	  InkPresenter.cs: Implement DP accessor generation.

2008-08-12  Rolf Bjarne Kvinge <RKvinge@novell.com> 

	* Canvas.cs, ColumnDefinition.cs, Control.cs, Grid.cs, Image.cs,
	  InkPresenter.cs, MediaElement.cs, Panel.cs, RowDefinition.cs,
	  TextBlock.cs, UserControl.cs: Make classes partial and remove DP
	  registration, which is now generated.

2008-08-11  Fernando Herrera  <fherrera@novell.com>

	* Control.cs: Add Style DP.
	* StackPanel.cs: Add StackPanel stub.

2008-08-09  Chris Toshok  <toshok@ximian.com>

	* ScrollBarVisibility.cs: nuke.

2008-08-09  Chris Toshok  <toshok@ximian.com>

	* Image.cs: change the Source property to be the right type for
	2.0 (doesn't work, though.. the DP is still a string).

2008-08-08  Fernando Herrera  <fherrera@novell.com>

	* Control.cs: Added some stubs methods for SL2
	* ContentControl.cs:
	* ControlTemplate.cs:
	* ItemCollection.cs:
	* ItemsControl.cs:
	* ItemsPanelTemplate.cs: Added stubs for SL2 beta2

2008-08-08  Sebastien Pouliot  <sebastien@ximian.com>

	* ChangeLog: Merge history
	* FileDialogFileInfo.cs: Moved from System.Windows.Browser.
	* OpenFileDialog.cs: Moved from System.Windows.Browser. Updated
	to SL2 beta2 API.

2008-08-05  Rolf Bjarne Kvinge <RKvinge@novell.com> 

	* UIElementCollection.cs: Deleted Visual (moved content into
	  UIElement), and renamed VisualCollection to UIElementCollection.

2008-08-03  Rolf Bjarne Kvinge <RKvinge@novell.com> 

	* MediaBase.cs: Deleted. Not used anymore.

2008-07-30  Jeffrey Stedfast  <fejj@novell.com>

	* TextBlock.cs: Make InlinesProperty private and remove ability to
	set the Inlines property.

	* MediaElement.cs: Source property is a Uri, not a
	string. Similarly, CurrentState is a MediaElementState and not a
	string. Remove ability to set the CurrentState.

	* Canvas.cs: Updated a bit.

	* Panel.cs: Fixed ctor and removed ability to set the Children
	property.

2008-07-29  Jeffrey Stedfast  <fejj@novell.com>

	* TextBlock.cs: Fixed FontFamily property.

	* Control.cs: Added properties and accessors.

2008-07-28  Jeffrey Stedfast  <fejj@novell.com>

	* Control.cs (.ctor): Made protected.
	(InitializeFromXaml): Seems this method no longer exists in
	Silverlight 2.0 Beta 2.

2008-07-28  Chris Toshok  <toshok@ximian.com>

	* MediaElement.cs: add some SecuritySafeCritical's.

	* ColumnDefinitionCollection.cs: stub out
	PresentationFrameworkCollection<T> overrides.

	* RowDefinitionCollection.cs: same.

2008-07-23  Rolf Bjarne Kvinge <RKvinge@novell.com> 

	* Panel.cs: More B2 updates.
	* UIElementCollection.cs: Added.

2008-07-23  Rolf Bjarne Kvinge <RKvinge@novell.com> 

	* MediaElement.cs: Removed MediaAttribute(Collection).

2008-07-23  Rolf Bjarne Kvinge <RKvinge@novell.com> 

	* MediaElement.cs: More B2 updates.

2008-07-23  Rolf Bjarne Kvinge <RKvinge@novell.com> 

	* TextBlock.cs: Updated TextDecoration* according to SL2B2.

2008-07-23  Rolf Bjarne Kvinge <RKvinge@novell.com> 

	* TextBlock.cs: Implement Font(Style|Weight|Stretch).

2008-07-23  Rolf Bjarne Kvinge <RKvinge@novell.com> 

	* Image.cs: Fixed ImageFailed signature.
	* MediaElement.cs: Fixed MediaFailed signature.
	* TextBlock.cs: Removed SetFontSource.

2008-07-22  Jeffrey Stedfast <fejj@novell.com>

	* ValidationErrorEventAction.cs: Added

	* ScrollBarVisibility.cs: Added

	* ClickMode.cs: Added

	* Orientation.cs: Added

	* MediaElement.cs: No longer inherits from MediaBase,
	AudioStreamIndex is now nullable, NaturalVideoWidth/Height are now
	int instead of double. Can no longer set Markers.

	* Image.cs: No longer inherits from MediaBase and removed
	DownloadProgress property.

2008-07-21  Jeffrey Stedfast  <fejj@novell.com>

	* TextBlock.cs: Use System.Windows.Documents.InlineCollection
	instead of System.Windows.Inlines.

2008-02-20  Jeffrey Stedfast  <fejj@novell.com>

	* TextBlock.cs (SetFontSource): It would appear that you can
	actually set null as a downloader (equivalent to unsetting it)
	according to the MS test suite.

2007-11-14  Sebastien Pouliot  <sebastien@ximian.com>

	* OpenFileDialog.cs: Changed Dispose to public. Don't reset files
	on Cancel. Added default "Open" title (when none is provided). Added
	filter validations that SL has.

2007-11-09  Jeffrey Stedfast  <fejj@novell.com>

	* MediaElement.cs (InvokeMediaOpened): Always pass null as the
	eventArgs parameter as defined by the msdn docs.
	(InvokeMediaEnded): Same.
	(InvokeMediaFailed): Same.

2007-11-08  Jeffrey Stedfast  <fejj@novell.com>

	* MediaElement.cs: Fixed all of the remove events to not /add/ the
	event ;-)
	(InvokeMarkerReached): Pass a TimelineMarkerEventArgs arg to the
	handler rather than null.

2007-10-04  Zoltan Varga  <vargaz@gmail.com>

	* Control.cs (InitialzeFromXaml): Load dependencies synchronously.

2007-10-02  Zoltan Varga  <vargaz@gmail.com>

	* Control.cs: Add some error checking.

2007-09-30  Jb Evain  <jbevain@novell.com>

	* MediaElement.cs: add setter for the AudioStreamCount DP.

2007-09-27  Rolf Bjarne Kvinge <RKvinge@novell.com> 

	* Canvas.cs, Panel.cs, TextBlock.cs, Image.cs, InkPresenter.cs,
	  MediaElement.cs, MediaBase.cs: Don't ref ourself if we're created using
	  a *_new function, the creation itself already gives us a ref.
	* Control.cs: Don't ref ourself if we're created using a *_new function, the
	  creation itself already gives us a ref. InitializeFromXaml: use the new
	  control_initialize_from_xaml_callbacks and specify a XamlLoader.

2007-09-14  Miguel de Icaza  <miguel@novell.com>

	* MediaBase.cs: Fixes the Uri crash from TopBanana.

2007-09-10  Chris Toshok  <toshok@ximian.com>

	* Image.cs: hookup ImageFailed, which a bunch of XXX's due to the
	missing marshalling of the ErrorEventArgs (which MediaElement also
	shares.)

2007-08-20  Jb Evain  <jbevain@novell.com>

	* MediaElement.cs: use methods in [agmono]Mono.Helper to avoid calling
	internal methods of mscorlib.

2007-08-09  Miguel de Icaza  <miguel@novell.com>

	* OpenFileDialog.cs: Do some bit of porting to use only what is
	available in the 2.1 profile.

2007-08-03  Chris Toshok  <toshok@ximian.com>

	* MediaElement.cs: switch NaturalDuration back to Duration.

2007-08-02  Jeffrey Stedfast  <fejj@novell.com>

	* MediaElement.cs: Add the new properties from the July 2007
	release and fixed NaturalDuration to be of type TimeSpan.

2007-07-31  Chris Toshok  <toshok@ximian.com>

	* MediaBase.cs: remove the events.

	* MediaElement.cs: and add them here.  also, hook them up to their
	unmanaged counterparts.

2007-07-25  Miguel de Icaza  <miguel@novell.com>

	* OpenFileDialog.cs: Implement support for returning more than one
	file in one pass.

2007-07-24  Miguel de Icaza  <miguel@novell.com>

	* OpenFileDialog.cs: Implement.

2007-07-09  Chris Toshok  <toshok@ximian.com>

	* Control.cs: don't pass the parser callbacks to
	control_initialize_from_xaml.

2007-07-07  Miguel de Icaza  <miguel@novell.com>

	* Image.cs (SetSource): simplify this routine by delegating all
	the work to unmanaged code.

2007-06-21  Rolf Bjarne Kvinge <RKvinge@novell.com> 

	* InkPresenter.cs, MediaElement.cs: Added.

2007-06-21  Rolf Bjarne Kvinge <RKvinge@novell.com> 

	* Panel.cs: Make this class abstract.

2007-06-20  Chris Toshok  <toshok@ximian.com>

	* Control.cs: pass the XamlReader callbacks to
	control_initialize_from_xaml.

2007-06-20  Chris Toshok  <toshok@ximian.com>

	* MediaBase.cs: the property is named Source, not Uri.

2007-06-18  Rolf Bjarne Kvinge <RKvinge@novell.com> 

	* TextBlock.cs: Fix FontWeight signature.

2007-06-18  Atsushi Enomoto  <atsushi@ximian.com>

	* TextBlock.cs : actually it was not in the build and needed couple
	  of fixes.

2007-06-17  Atsushi Enomoto  <atsushi@ximian.com>

	* TextBlock.cs : actually PInvokes are already in moon.

2007-06-17  Atsushi Enomoto  <atsushi@ximian.com>

	* TextBlock.cs : oops, extra field.

2007-06-17  Atsushi Enomoto  <atsushi@ximian.com>

	* TextBlock.cs : new.

2007-06-16  Sebastien Pouliot  <sebastien@ximian.com>

	* Control.cs: Use the Kind return from create to do the lookup.

2007-06-16  Sebastien Pouliot  <sebastien@ximian.com> 

	* Image.cs: Try to get completed notification.
	* MediaBase.cs: End-helper for Image.

2007-06-15  Sebastien Pouliot  <sebastien@ximian.com> 

	* Image.cs: New.
	* MediaBase.cs: New.

2007-06-15  Sebastien Pouliot  <sebastien@ximian.com>

	* Control.cs: New.

2007-06-13  Rolf Bjarne Kvinge <RKvinge@novell.com> 

	* Canvas.cs, Panel.cs: Second pass on constructors.

2007-06-13  Rolf Bjarne Kvinge <RKvinge@novell.com> 

	* Panel.cs: Fix constructor, don't construct anything if we're not the
	  class to construct.

2007-06-13  Rolf Bjarne Kvinge <RKvinge@novell.com> 

	* Panel.cs: Use native constructors.

2007-06-13  Rolf Bjarne Kvinge <RKvinge@novell.com> 

	* Canvas.cs, Panel.cs: Implement GetKind.

2007-06-07  Miguel de Icaza  <miguel@novell.com>

	* Canvas.cs, Panel.cs: Rework to use the dependency properties
	registered in the unmanaged side, remove dead code.

2007-06-06  Atsushi Enomoto  <atsushi@ximian.com>

	* FileDialogFileInfo.cs,
	  OpenFileDialog.cs : some imaginary implementation using DllImports
	  where those unmanaged functions do not exist.

2007-06-04  Miguel de Icaza  <miguel@novell.com>

	* Canvas.cs: Add native IntPtr field that points to the native
	canvas object.

	Should this be part of DependencyObject?  

	Need to decide.

	* Panel.cs: Add the early binding to the collection.

2007-06-02  Atsushi Enomoto  <atsushi@ximian.com>

	* DialogResult.cs FileDialogFileInfo.cs OpenFileDialog.cs : stubs.
